/*
 * Control GPIO pins on the fly
 *
 * Copyright (c) 2008-2011 Analog Devices Inc.
 *
 * Licensed under the GPL-2 or later.
 */

#include <common.h>
#include <command.h>
#include <asm/arch/gpio.h>

#ifndef name_to_gpio
#define name_to_gpio(name) simple_strtoul(name, NULL, 10)
#endif

static int first = 1;
enum gpio_cmd {
	GPIO_IN,
	GPIO_SET,
	GPIO_CLEAR,
	GPIO_TOGGLE,
};

static int do_emmc_gpio(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	int gpio;
	enum gpio_cmd sub_cmd;
	ulong value;
	const char *str_cmd, *str_gpio;
	struct exynos5_gpio_part1 *gpio1 =
        (struct exynos5_gpio_part1 *) samsung_get_base_gpio_part1();
    gd_t *gd;//crazyboy
#ifdef gpio_status
	if (argc == 2 && !strcmp(argv[1], "status")) {
		gpio_status();
		return 0;
	}
#endif

	//if (argc != 3)
	if (argc != 2)
 show_usage:
		return CMD_RET_USAGE;
	str_cmd = argv[1];
	//str_gpio = argv[2];
	
	if(first)
	{
		s5p_gpio_set_pull(&gpio1->b0, 0, GPIO_PULL_NONE);
		s5p_gpio_direction_output(&gpio1->b0, 0, 0);
		s5p_gpio_set_pull(&gpio1->b0, 1, GPIO_PULL_NONE);
		s5p_gpio_direction_output(&gpio1->b0, 1, 1);
		
		s5p_gpio_set_pull(&gpio1->b0, 2, GPIO_PULL_NONE);
		s5p_gpio_direction_output(&gpio1->b0, 2, 0);
		s5p_gpio_set_pull(&gpio1->b0, 3, GPIO_PULL_NONE);
		s5p_gpio_direction_output(&gpio1->b0, 3, 0);
	    s5p_gpio_set_pull(&gpio1->b0, 4, GPIO_PULL_NONE);
		s5p_gpio_direction_output(&gpio1->b0, 4, 0);
		
		s5p_gpio_set_pull(&gpio1->x1, 7, GPIO_PULL_NONE);
		s5p_gpio_direction_output(&gpio1->x1, 7, 0);
		s5p_gpio_set_pull(&gpio1->x2, 0, GPIO_PULL_NONE);
		s5p_gpio_direction_output(&gpio1->x2, 0, 0);
		
		s5p_gpio_set_pull(&gpio1->x2, 1, GPIO_PULL_NONE);
		s5p_gpio_direction_output(&gpio1->x2, 1, 0);
		s5p_gpio_set_pull(&gpio1->x2, 2, GPIO_PULL_NONE);
		s5p_gpio_direction_output(&gpio1->x2, 2, 1);
	    s5p_gpio_set_pull(&gpio1->x2, 3, GPIO_PULL_NONE);
		s5p_gpio_direction_output(&gpio1->x2, 3, 1);
	
	//by crazyboy 20130812	
		s5p_gpio_set_pull(&gpio1->x0, 6, GPIO_PULL_NONE);
		s5p_gpio_direction_output(&gpio1->x0, 6, 0);
		first = 0;
	}
	/* parse the behavior */
	switch (*str_cmd) {
		case 's': sub_cmd = GPIO_SET;    break;
		case 'c': sub_cmd = GPIO_CLEAR;  break;
		default:  goto show_usage;
	}

	/* turn the gpio name into a gpio number */
	//gpio = name_to_gpio(str_gpio);

	/* finally, let's do it: set direction and exec command */
	switch (sub_cmd) {
		case GPIO_SET:    value = 1;
		s5p_gpio_set_value(&gpio1->b0,0,value);s5p_gpio_set_value(&gpio1->b0,1,0);
		s5p_gpio_set_value(&gpio1->b0,2,value);s5p_gpio_set_value(&gpio1->b0,3,value);
		s5p_gpio_set_value(&gpio1->b0,4,value);
        s5p_gpio_set_value(&gpio1->x1,7,value);s5p_gpio_set_value(&gpio1->x2,0,value);
		s5p_gpio_set_value(&gpio1->x2,1,value);s5p_gpio_set_value(&gpio1->x2,2,0);
		s5p_gpio_set_value(&gpio1->x2,3,0);

		break;
		case GPIO_CLEAR:  value = 0; 
        s5p_gpio_set_value(&gpio1->b0,0,value);s5p_gpio_set_value(&gpio1->b0,1,1);
		s5p_gpio_set_value(&gpio1->b0,2,value);s5p_gpio_set_value(&gpio1->b0,3,value);
		s5p_gpio_set_value(&gpio1->b0,4,value);
        s5p_gpio_set_value(&gpio1->x1,7,value);s5p_gpio_set_value(&gpio1->x2,0,value);
		s5p_gpio_set_value(&gpio1->x2,1,value);s5p_gpio_set_value(&gpio1->x2,2,1);
		s5p_gpio_set_value(&gpio1->x2,3,1);


		break;
		default:          goto show_usage;
	}

#if 0//crazyboy 130821
	switch(gpio)
	{
        case 33 : s5p_gpio_set_value(&gpio1->b0,3,value); break;
        case 18 : s5p_gpio_set_value(&gpio1->b0,4,value); break;
		default : goto show_usage;
	}
#endif	

	printf("GPB0_3(3.3v) value = %d \n",s5p_gpio_get_value(&gpio1->b0,3));
	printf("GPB0_4(1.8v) value = %d \n",s5p_gpio_get_value(&gpio1->b0,4));
//by crazyboy 20130812	
#if 1
	s5p_gpio_set_value(&gpio1->x0,6,0);
	mdelay(100);
	s5p_gpio_set_value(&gpio1->x0,6,1);	
	mdelay(1000);
    //crazyboy 130808
	if(value==1)
	{
		mmc_initialize(gd->bd);
	}
#endif
	return value;
}

U_BOOT_CMD(emmc_gpio, 3, 0, do_emmc_gpio,
	"emmc 1.8v/3.3v Enable Gpio Control",
	"<set-1|clear-0> \n"
	"    -ex) Enable : emmc_gpio set  \n"
	"    -ex) clear : emmc_gpio clear  \n"
	);

